#define LETSTRYINTERRUPT

#include <stddef.h>
#include "stm32f10x.h"
#include "STM32_Discovery.h"

int Ts, cnt, y;
short int yy;
volatile int z;
volatile short int dance;

void flash(){
  if (yy > 0) yy+=80; else yy-=50;
  y+=yy;
  if (y > 30000) yy=-300;
  if (y < 0) {yy=400;y=0;}

  if (dance == 0) for (z=0;z<y;z++);

  STM32_Discovery_LEDOn(LED4);
  for (z=0;z<800;z++);
  STM32_Discovery_LEDOff(LED4);
}


#ifdef LETSTRYINTERRUPT
void EXTI0_IRQHandler(void)
{
  if(EXTI_GetITStatus(USER_BUTTON_EXTI_LINE) != RESET)
  {
	 if (dance != 0) {
		 dance = 0;
	 } else {
		 dance = 1;
	 }

    /* Clear the User Button EXTI line pending bit */
    EXTI_ClearITPendingBit(USER_BUTTON_EXTI_LINE);
  }
}
void EXTI1_IRQHandler(void)
{
  if(EXTI_GetITStatus(USER_INPUT_EXTI_LINE) != RESET){
	if (++cnt>1){
	  cnt=0;
      flash();
    }

    /* Clear the User Button EXTI line pending bit */
    EXTI_ClearITPendingBit(USER_INPUT_EXTI_LINE);
  }
}
#endif



int main(void)
{
  STM32_Discovery_LEDInit(LED3);
  STM32_Discovery_LEDInit(LED4);

#ifdef LETSTRYINTERRUPT
  STM32_Discovery_PBInit(BUTTON_USER, BUTTON_MODE_EXTI);
  STM32_Discovery_PBInit(BUTTON_INPUT, BUTTON_MODE_EXTI);
#else
  STM32_Discovery_PBInit(BUTTON_USER, BUTTON_MODE_GPIO);
  STM32_Discovery_PBInit(BUTTON_INPUT, BUTTON_MODE_GPIO);
#endif
  STM32_Discovery_LEDOff(LED3);
  STM32_Discovery_LEDOff(LED4);


  STM32_Discovery_LEDOff(LED3);
  STM32_Discovery_LEDOn(LED4);


  Ts = 0;
  cnt = 0;
  y = 0;
  yy = 1;
  dance = 0;

#ifdef LETSTRYINTERRUPT
  while(1);
#else
  while(1){
	  while(Ts == STM32_Discovery_PBGetState(BUTTON_INPUT));
	  if (Ts == 0) { Ts = 1;} else {Ts = 0;}
	  if (++cnt>3) {
		  cnt=0;
		  if (STM32_Discovery_PBGetState(BUTTON_USER)) {dance = 1;} else {dance = 0;}
		  flash();
	  }
  }
#endif
}


void __assert_func(const char *file, int line, const char *func, const char *failedexpr)
{
  while(1);
}

void __assert(const char *file, int line, const char *failedexpr)
{
   __assert_func (file, line, NULL, failedexpr);
}
